//+------------------------------------------------------------------+ 
//|   TRO_PERIOD_OPENS                                               | 
//|                                                                  | 
//|   Copyright  2009, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/fx/ as your forex broker  |  
//| ...tell them therumpledone sent you!                             |  
//+------------------------------------------------------------------+ 


#property  copyright "Copyright  2009, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 

#property indicator_chart_window




extern bool   Show.Gauge     = true ; 
extern bool   Show.Lines     = true ;
extern bool   Show.Labels    = true ;
extern bool   Show.PriceBox  = true ;
extern int    myBoxWidth     = 1;

extern int    ShiftLabel =  10 ;
 



extern int myPeriod = 0 ;

extern int myBars   = 24 ;
extern int myShift  = 1 ;



extern color colorOpen  = Orange ;


extern int myChartX   = 10 ;
extern int myChartY   = 100 ;  
  
extern int myCorner   = 1 ;
extern string myFont  = "Courier New" ;
extern int myFontSize = 12 ;


//+------------------------------------------------------------------+

string lbl[15], lbl2[15];
int n, j, k ;

color pColor = Blue ;

string symbol, tChartPeriod, ShortName, TAG ; 
 
int    digits, period, win ; 

double point,  open, high, low, close, mid, range, pClose, pOpen, pHigh, pLow, pMid, pRange, cRange, PipDiff, HH, LL  ;  

int FillAmt = 11 , x001, x002, x003, x004, x005, x006, x007 ;   

string   HHMM,  thisHHMM ;

int thisHH = 99;

datetime thisDATE ;

//+------------------------------------------------------------------+

int init()
  {
   if(myPeriod == 0) { period = Period() ; } else { period = myPeriod ; }    
   tChartPeriod =  TimeFrameToString(period) ;
   symbol       =  Symbol() ;
   digits       =  Digits ;
   point        =  Point ;
   TAG          = "PEROPS" ; 
   ShortName    = TAG+symbol+period ;
   win          = 0 ;


   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; }   
  
   
if( myCorner == 0 || myCorner == 2 )
{ 
   x001 = 0 ;
   x002 = 0 ;
   x003 = 90 ; 
   x004 = 150;
   x005 = 100 ;
   x006 = 90 ;  
   x007 = 90 ;
   FillAmt = 20 ;     
}
else
{
   x001 = 10 ;
   x002 = 80 ; //  
   x003 = 50 ;  //  
   x004 = 0 ; //  
   x005 = 10 ;
   x006 = 10 ;  
   x007 = 10 ;   
   FillAmt = 20 ; 
}
        
  
  deinit();   
   
   return(0);
  }
  
  
//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }
    
//+------------------------------------------------------------------+
int deinit()
  {
    
   ObDeleteObjectsByPrefix(TAG);          
   TRO() ;
   
   return(0);
  }
  
//+------------------------------------------------------------------+
int start()
{

n       = 10;
j       = 0 ;
if(Show.Gauge) 
{
lbl[j]  = ShortName+j;
lbl2[j] = fFill(tChartPeriod + " Open Price   +/-", 19) ;
DoShowHead(j, SteelBlue);
}
close    = iClose( symbol, 0, 0) ;

for( k = 0+myShift; k < myBars+myShift; k++ )
{
   
open     = iOpen( symbol, period, k) ; 

if(period < 1440)
{
   thisHH      = TimeHour(Time[k]) ;
   if( thisHH < 10) { thisHHMM = "0" + thisHH + ":00" ; } else  { thisHHMM = thisHH + ":00" ; }
}
else
{
   thisDATE = iTime( symbol, period, k) ;
   thisHHMM = StringSubstr(TimeToStr(thisDATE,TIME_DATE),5,5) ;
} 
 
j       = j + 1 ;
lbl[j]  = ShortName+j;
lbl2[j] = fFill(thisHHMM,11) ;
PipDiff = ( close - open ) / point ; 
DoColor( close, open ) ; 
if(Show.Gauge) { DoShow(j, colorOpen, open); }
if(Show.Lines) { drawLine(open,TAG+thisHHMM+k, colorOpen, 2,thisHHMM+" "+DoubleToStr(open,digits) ) ; }
if(Show.PriceBox) {DoBox( open,TAG+thisHHMM+k+"B", colorOpen , myBoxWidth ) ; }
} // for


 

   return(0);
  }
//+------------------------------------------------------------------+
  
void DoShowHead( int u, color dsColor )
{
string rlabelH = lbl[u] + "Head" ;
ObjectCreate(rlabelH,23,0,Time[0],PRICE_CLOSE);
ObjectSet(rlabelH, OBJPROP_CORNER, myCorner );
ObjectSet(rlabelH,OBJPROP_XDISTANCE, x001+myChartX);
ObjectSet(rlabelH,OBJPROP_YDISTANCE,n+myChartY);
ObjectSetText(rlabelH,lbl2[u],myFontSize,myFont,dsColor);

n = n+20;

return(0);
}
//+------------------------------------------------------------------+
  
void DoShow( int u, color dsColor, double dsPrice )
{
ObjectCreate(lbl[u],23,0,Time,PRICE_CLOSE);
ObjectSet(lbl[u], OBJPROP_CORNER, myCorner );
ObjectSet(lbl[u],OBJPROP_XDISTANCE,x002+myChartX);
ObjectSet(lbl[u],OBJPROP_YDISTANCE,n+myChartY);
ObjectSetText(lbl[u],lbl2[u],14,myFont,dsColor);

string Obj001 = lbl[u] + "price" ;
string sVal = fFill(DoubleToStr(dsPrice,digits), 7)    ;
ObjectCreate(Obj001,23,0,Time[0],PRICE_CLOSE);
ObjectSet(Obj001, OBJPROP_CORNER, myCorner );
ObjectSet(Obj001,OBJPROP_XDISTANCE, x003+myChartX);
ObjectSet(Obj001,OBJPROP_YDISTANCE,n+myChartY);
ObjectSetText(Obj001,sVal,myFontSize,myFont,dsColor);


string Obj002 = lbl[u] + "avg" ;
string sDif =  rtadjust( DoubleToStr(PipDiff,0) ) ;
ObjectCreate(Obj002,23,0,Time[0],PRICE_CLOSE);
ObjectSet(Obj002, OBJPROP_CORNER, myCorner );
ObjectSet(Obj002,OBJPROP_XDISTANCE, x004+myChartX);
ObjectSet(Obj002,OBJPROP_YDISTANCE,n+myChartY);
ObjectSetText(Obj002,sDif,myFontSize,myFont,pColor);

n = n+20;

   return(0);
  }



//+------------------------------------------------------------------+
  
void DoColor( double c1, double c2 )
{

if(c1 > c2 ) { pColor = Lime ; } else {
if(c1 < c2 ) { pColor = Red ; } else { pColor = Yellow ; } } 

}  

//+------------------------------------------------------------------+
void drawLine(double lvl,string name, color Col,int type,string text)
{
         if(ObjectFind(name) != 0)
         {
            ObjectCreate(name, OBJ_TREND, 0, Time[0], lvl,Time[1],lvl);
            
            if(type == 1)
            ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);
            else
            ObjectSet(name, OBJPROP_STYLE, STYLE_DOT);
            
            ObjectSet(name, OBJPROP_COLOR, Col);
            ObjectSet(name,OBJPROP_WIDTH,1);
            ObjectSet(name,OBJPROP_RAY,true);
            
         }
         else
         {
            ObjectDelete(name);
            ObjectCreate(name, OBJ_TREND, 0, Time[0], lvl,Time[1],lvl);
            
            if(type == 1)
            ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);
            else
            ObjectSet(name, OBJPROP_STYLE, STYLE_DOT);
            
            ObjectSet(name, OBJPROP_COLOR, Col);        
            ObjectSet(name,OBJPROP_WIDTH,1);
            ObjectSet(name,OBJPROP_RAY,true);
          
         }

if(Show.Labels)
{         
   string Obj0002 = name+"linelbl" ;
      ObjectDelete(Obj0002);
      if(ObjectFind(Obj0002) != 0)
      {
         ObjectCreate(Obj0002, OBJ_TEXT, 0, Time[ShiftLabel], lvl);
         ObjectSetText(Obj0002,text , 8, "Arial", Col);
      }
      else
      {
         ObjectMove(Obj0002, 0, Time[ShiftLabel], lvl);
      } // if     
           
} // if
               
}// void

//+------------------------------------------------------------------+
string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}

//+------------------------------------------------------------------+

string fFill(string filled, int f ) 
{
   string FILLED ;
   
   FILLED = StringSubstr(filled + "                                         ",0,f) ;
   
return(FILLED);
}



//+------------------------------------------------------------------+
string rtadjust( string rString )
{
 
 int sl = StringLen(rString) ;
 
 while(true)
 {
 
   if( sl == 5) { break ; } 
   if( sl == 4) { rString = " " + rString ; break ; }    
   if( sl == 3) { rString = "  " + rString ; break ; } 
   if( sl == 2) { rString = "   " + rString ; break ; } 
   if( sl == 1) { rString = "    " + rString ; break ; } 
    
   break ;
 }

return(rString) ;
}       

//+--------- TRO MODIFICATION ---------------------------------------+  
void DoBox(double lvl,string name, color Col , int Width )    
{

      if (ObjectFind(name) != 0)
      {
          ObjectCreate(name,OBJ_ARROW,0,Time[0],lvl);
          ObjectSet(name,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(name,OBJPROP_COLOR,Col);  
          ObjectSet(name,OBJPROP_WIDTH,Width);  
      } 
      else
      {
         ObjectMove(name,0,Time[0],lvl);
         ObjectSet(name,OBJPROP_COLOR,Col);  
      }
      
} // void      
//+------------------------------------------------------------------+  
 
void TRO()
{   
   
   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}


//+------------------------------------------------------------------+

/*


  
//+------------------------------------------------------------------+
void drawLabel(string name,double lvl,color Color)
{
    if(ObjectFind(name) != 0)
    {
        ObjectCreate(name, OBJ_TEXT, 0, Time[10], lvl);
        ObjectSetText(name, name, 14, "Arial", EMPTY);
        ObjectSet(name, OBJPROP_COLOR, Color);
    }
    else
    {
        ObjectMove(name, 0, Time[10], lvl);
    }
}

*/